import greenfoot.*;

/**@Douglas Chu  
 * @1.1
 * Various code "borrowed" from Mr. Cohen and Michael Kolling.
 * Earth image taken from Google Images.
 * Counter image taken from Michael Kolling's blog.
 * "universecentre.mp3" and "left4death.mp3" taken from YouTube.
 * WASD keys for Robot. Arrow keys for Assistance. Eat aliens; keep them away from Earth.
 * Whoever captures more aliens than the other before the aliens take Earth is the winner. 
 * 1-2 players. Alien getting to Earth = Game Over!
 * Teamwork is encouraged, but foul/selfish play is (unfortunately) allowed.
 * Cannot seem to allow level advancing or changing. 
 */
public class Atmosphere extends World
{
    //Variables and array.
    private int level = 1;
    private Alien[] aliens;
    private Robot robot;
    private Fader fader;    
    private Counter counter;
    //private LevelCounter levelCounter;
    private Earth earth;
    private Assistance assistance;
    private Score2 score2;
    private int score;
    /**
     * Constructor for objects of class Atmosphere.
     * 
     */
    public Atmosphere()
    {    
        //Size of the world, in pixels.
        super(750, 550, 1); 
        //Set what appears in between levels.
        setPaintOrder (Fader.class, Alien.class, Assistance.class, Robot.class, Earth.class);
        //Set text in level counter and added to world.
        //levelCounter = new LevelCounter ("Level: ");
        //addObject (levelCounter, 50, 30);
        //Initialized fader and added to world.
        fader = new Fader();
        addObject (fader, 375, 275);
        //Sets level number.
        //levelCounter.setValue(level);
        setNextLevel();
        score = 0;
        //Initialized counter.
        counter = new Counter();
        prepare();
    }
    //Yay theme music!
    private GreenfootSound music = new GreenfootSound("universecentre.mp3");
    private GreenfootSound failMusic = new GreenfootSound("left4death.mp3");
    //Whenever program is run, "universecentre.mp3" plays. 
    public void started()  
    {  
        music.playLoop();
    }  
    //Whenever program is stopped after being run, "universecentre.mp3" stops. 
    public void stopped()  
    {  
        music.stop();
    } 
    //Save The World command used to save actors in the world.
    private void prepare()
    {
        Counter counter = new Counter();
        addObject(counter, 699, 33);
        Robot robot = new Robot(counter);
        addObject(robot, 394, 296);
        Score2 score2 = new Score2();
        addObject(score2, 68, 536);
        Assistance assistance = new Assistance(score2);
        addObject(assistance, 219, 299);
        Alien alien = new Alien();
        addObject(alien, 582, 307);
        assistance.setLocation(275, 380);
        robot.setLocation(270, 247);
        robot.setLocation(227, 166);
        assistance.setLocation(228, 398);
        alien.setLocation(581, 281);
        counter.setLocation(692, 27);
        Earth earth = new Earth();
        addObject(earth, 67, 294);
        removeObject(earth);
        robot.setLocation(208, 249);
        assistance.setLocation(203, 304);
        Alien alien2 = new Alien();
        addObject(alien2, 590, 346);
        Alien alien3 = new Alien();
        addObject(alien3, 586, 224);
        Alien alien4 = new Alien();
        addObject(alien4, 585, 170);
        Alien alien5 = new Alien();
        addObject(alien5, 584, 107);
        Alien alien6 = new Alien();
        addObject(alien6, 588, 54);
        Alien alien7 = new Alien();
        addObject(alien7, 606, 405);
        Alien alien8 = new Alien();
        addObject(alien8, 601, 462);
        Alien alien9 = new Alien();
        addObject(alien9, 596, 526);
        counter.setLocation(149, 106);
        counter.setLocation(65, 32);
        Earth earth2 = new Earth();
        addObject(earth2, 71, 290);
        removeObject(alien9);
        removeObject(alien8);
        removeObject(alien7);
        removeObject(alien2);
        removeObject(alien);
        removeObject(alien3);
        removeObject(alien4);
        removeObject(alien5);
        removeObject(alien6);
        counter.setLocation(52, 70);
        score2.setLocation(62, 509);
        counter.setLocation(57, 28);
        earth2.setLocation(37, 278);
        robot.setLocation(113, 256);
        assistance.setLocation(111, 312);
    }
    //All the world needs to do is spawn aliens.
    public void act()
    {
        spawnAliens();
    }
    /**Bug is located here (and in next method), but fader is needed to keep the world lit. 
     * If not, the world is almost completely black. 
     */
    public void setNextLevel ()
    {
        aliens = new Alien[level * 20];
        for (int i = 0; i < aliens.length; i++)
        {
            aliens[i] = new Alien ();
        }
        fader.fadeBackIn();
    }
    //Bugged method #2.
    public void endLevel()
    {
        fader = new Fader ();
        addObject (fader, 400, 300);
        for (int i = 0; i < aliens.length; i++)
        {            
            removeObject (aliens[i]);
        }
        level++;
        counter.setValue (level);
        setNextLevel();
    }
    //Spawn aliens method.
    private void spawnAliens()
    {
        if (Greenfoot.getRandomNumber(50) == 1)
        {
            addObject (new Alien(), 650, Greenfoot.getRandomNumber(400));
        }
    }
    //Game over method; plays "left4death.mp3" once Alien.class collides with Earth.class, and stops program.
    public void gameOver()
    {
        failMusic.play();
        Greenfoot.stop();
    }
}
